#!/usr/bin/env python
import sys;
import base64;
from suds import WebFault;
from suds.client import Client;
flux=Client('http://13cflux.net/FluxWS/Flux?wsdl');
params=flux.factory.create('ns1:parameter');
dt=flux.factory.create('dataFileType');

tas=len(sys.argv);
#print tas;
h=0;
k=0;
l=0;
m=0;
fwd_in=0;
input2=0;
output=0;
dt_p=0;
anzahl=1;
if (len(sys.argv) > 1 ):
 for i in range(1,len(sys.argv)):
  if (sys.argv[i]=="-h"):
   print "SETFLUXES -- HDF5,FWDSIM,CSV to FluxML filter (c) T. Dalman, M. Weitzel 2010\nSYNTAX: setfluxes (-C <csvfile>|-F <fwdsimfile>|-H <hdf5file>) -l <num>\n                  [-V <path to flux names>] [-D <path to flux values>]\n                  [-i <FluxML input>] [-o <FluxML output>] \n  -i <file>   input FluxML file (stdin if omitted)\n  -o <file>   output FluxML file (stdout if omitted)\n  -l <num>    index of dataset to read (CSV, HDF5, >=1, default: 1)\n  -f          force; insert/replace the set of free fluxes even if they were\n              not specified in the input FluxML \n  -C <file>   CSV data file\n  -F <file>   FWDSIM data file\n  -H <file>   HDF5 data file\n  -D <h5name> HDF5 path to flux values (default: '/flux/data')\n  -V <h5name> HDF5 path to flux names (default: '/flux/names')"
   h=1;
   # if h==0:
   # for i in range(1,len(sys.argv)):
   #      if (i=="-o"):
   #	 peter=1;
   #	 file=sys.argv[i+1]
 if (h==0):
  for i in range(1,len(sys.argv)):	
   if (sys.argv[i]=="-i"):
    input2=sys.argv[i+1]
    k=1;
   if (sys.argv[i]=="-o"):
    output=sys.argv[i+1]
    l=1;
   if (sys.argv[i]=="-f"):
    params.setfluxes.force=True;
   if (sys.argv[i]=="-D"):
    params.setfluxes.hdf5data=sys.argv[i+1];
   if (sys.argv[i]=="-V"):
    params.setfluxes.hdf5names=sys.argv[i+1];
   if (sys.argv[i]=="-l"):
    anzahl=int(sys.argv[i+1]);
  if (m==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-F"):
     fwd_in=sys.argv[i+1];
     dt_p=dt.DATAFILE_FWDSIM;
     m=1
  if (m==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-H"):
     fwd_in=sys.argv[i+1];
     dt_p=dt.DATAFILE_HDF5;
     m=1
  if (m==0):
   for i in range(1,len(sys.argv)):
    if (sys.argv[i]=="-C"):
     fwd_in=sys.argv[i+1];
     dt_p=dt.DATAFILE_CSV;
     m=1
  if (k==1):
   if (m==1):
    if (l==1):
     fml_f = open(input2, 'rb');
     fml   = base64.b64encode(fml_f.read());
     fml_f.close();
     
     fwd_f = open(fwd_in, 'rb');
     fwd   = base64.b64encode(fwd_f.read());
     fwd_f.close();
     try:
      res=flux.service.Setfluxes(fml,dt_p,fwd,anzahl,params);
     except WebFault, e:
     	print 'Failed to invoke web service:';
    	print e.fault.faultstring;
    	exit(1);
     p=open(output, 'wb')
     p.write(base64.b64decode(res))
     p.close()
    if (l==0): #& k==1):
     fml_f = open(input2, 'rb');
     fml   = base64.b64encode(fml_f.read());
     fml_f.close();

     fwd_f = open(fwd_in, 'rb');
     fwd   = base64.b64encode(fwd_f.read());
     fwd_f.close();
     try:
      res=flux.service.Setfluxes(fml,dt_p,fwd,anzahl,params);
     except WebFault, e:
        print 'Failed to invoke web service:';
        print e.fault.faultstring;
        exit(1);
     print base64.b64decode(res)
   if(m==0):
    print "You have to specify an HDF5, FWD or CSV input file [-H /-F /-C FILE]"
  if (k==0):
   print "You have to specify an input file [-i FILE]"
else:
 print "You have to specify an input file [-i FILE]"
