#!/usr/bin/env python
import sys;
import base64;
from suds import WebFault;
from suds.client import Client;
flux=Client('http://13cflux.net/FluxWS/Flux?wsdl');
params=flux.factory.create('ns1:parameter');

tas=len(sys.argv);
#print tas;
h=0;
k=0;
l=0;
input2=0;
output=0;
if (len(sys.argv) > 1 ):
 for i in range(1,len(sys.argv)):
  if (sys.argv[i]=="-h"):
   print "*** This version of 13CFLUX 2 is licensed to:\n*** Demo Version, FZ Juelich\nStoichiometry Scanner (c) 2010 Michael Weitzel\nSyntax: sscanner <parameters>\n  -i/--in <file>        FluxML input file (stdin if omitted)\n  -o/--out <file>       FluxML output file (stdout if omitted)\n  -r/--resample [nx]    resampling targets: net fluxes (n), exchange fluxes (x)\n                        default is to resample both net and exchange fluxes\n  -b/--bound-net <num>  bound for the magnitude of unbounded NET fluxes\n  -p/--bound-xch <num>  bound for the magnitude of unbounded XCH fluxes\n  -m/--montecarlo <num> initialize fluxes from the centroid of a point cloud\n                        requires the number of random points to be specified\n  -B/--bounds           list the lower and upper bounds of the free fluxes"
   h=1
 if (h==0):
  for i in range(1,len(sys.argv)):	
   if (sys.argv[i]=="-i"):
    input2=sys.argv[i+1]
    k=1;
   if (sys.argv[i]=="-o"):
    output=sys.argv[i+1]
    l=1;
   if (sys.argv[i]=="-B"):
    params.sscanner.bounds=True;
   if (sys.argv[i]=="-m"):
    params.sscanner.montecarlo=int(sys.argv[i+1]);
   if (sys.argv[i]=="-r"):
    params.sscanner.resample=sys.argv[i+1];
   if (sys.argv[i]=="-p"):
    params.sscanner.bound_xch=float(sys.argv[i+1]);
   if (sys.argv[i]=="-b"):
    params.sscanner.bound_net=float(sys.argv[i+1]);
  if (k==1):
   if (l==1):
    fml_f = open(input2, 'rb');
    fml   = base64.b64encode(fml_f.read());
    fml_f.close();
    try:
     res=flux.service.SScanner(fml,params);
    except WebFault, e:
    	print 'Failed to invoke web service:';
    	print e.fault.faultstring;
    	exit(1);
    p=open(output, 'wb')
    p.write(base64.b64decode(res))
    p.close()
   if (l==0): #& k==1):
    fml_f = open(input2, 'rb');
    fml   = base64.b64encode(fml_f.read());
    fml_f.close();
    try:
     res=flux.service.SScanner(fml,params);
    except WebFault, e:
        print 'Failed to invoke web service:';
        print e.fault.faultstring;
        exit(1);
    print base64.b64decode(res)
  if (k==0):
   print "You have to specify an input file"
else:
 print "You have to specify an input file"
